#include <iostream>
#include <cassert>
#include <cstdlib> //For rand
#include <ctime> //For time
using namespace std;

int func1(int* a) {
	return 0;
}

int* func2(int* a) {
	return 0;
}

int func3(int* a) {
	return 0;
}

int func4(int** a) {
	return 0;
}

int func5(int* a) {
	return 0;
}

int func6(int* a) {
	return 0;
}

//Hard mode. You don't have to solve these, but you're pretty cool if you do!

int func7(int* a) {
	return 0;
}
int func8(int** a) {
	return 0;
}
int* func9(int* a) {
	return 0;
}
int func10(char* a) {
	return 0;
}

	
int main() {
	srand(time(NULL)); //Seed the RNG with the current time
	int var = rand(); //rand() returns a random number
	int* varPtr = &var;
	assert(func1(varPtr) == var);
	cout << "func1 completed successfully" << endl;
	
	assert(func2(&*varPtr) == &var);
	cout << "func2 completed successfully" << endl;
	
	assert(func3(&var) == var + 1);
	cout << "func3 completed successfully" << endl;
	
	assert(func4(&varPtr) == 2*var);
	cout << "func4 completed successfully" << endl;
	
	/*
	Let's talk about arrays. When I say int arr[3], I allocate space for
	three consecutive integers somewhere in memory. The computer knows how
	much space each int requires - Let's say it is 8 bytes. Then a total
	of 8*8*3 = 192 bits need to be allocated for my int arr[3].
	
	The variable arr is really a pointer to the first int in the array, 
	and arr[0] is just another way of dereferencing that pointer. That is,
	*arr and arr[0] are perfectly equivalent. Since I know the memory
	address of the first int in the array, and I know the size of an int
	(8 bytes), I automatically know the memory addresses of all the 
	elements in that array. Typing arr[2] is the same as saying "take the
	memory address of the first element in arr, add 2*8 bytes to that
	number and return whatever this new memory address points to". As you
	might have guessed, an equivalent way of doing this would be to type
	*(arr + 2). Pointers understand addition in a special way - Adding 2
	to arr does not mean "add 2 to the memory address of arr" but "add the
	size of 2 ints to the memory address of arr". If you do
	
	cout << sizeof(int) << endl;
	cout << arr << endl;
	cout << arr + 2 << endl;
	
	you can see for yourself that arr + 2 equals arr plus the size of two
	ints. Anyway, keep this in mind when solving the exercise: If you have
	the memory address of any element in an array, you can easily get both
	the memory address or the value of any other element in that array.
	*/
	
	int arr[3] = {rand(), rand(), rand()}; //Array filled with three random numbers
	
	assert(func5(arr) == arr[2]);
	cout << "func5 completed successfully" << endl;
	
	assert(func6(arr+3) == *arr);
	cout << "func6 completed successfully" << endl;
	
	/*
	These might be a bit more of a challenge. You don't have to solve 
	them, but feel free to try if you found the other ones too easy!
	*/
	//assert(func7(varPtr - 2) == var - 2);
	//cout << "func7 completed successfully" << endl;
	
	//assert(func8(&varPtr + 1) == var/2);
	//cout << "func8 completed successfully" << endl;
	
	//assert(func9(&arr[4]) == arr);
	//cout << "func9 completed successfully" << endl;
	
	//assert(func10((char*)arr + 2) == arr[3]);
	//cout << "func10 completed successfully" << endl;
	
	cout << "All tests completed successfully!" << endl;
	
	return 0;
}
