#include <iostream>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <utility>
#include <cassert>
#include "maxVal.h"
using namespace std;

int main() {
	const int nVals = 10; //Make up some values. Using arrays because they can be initialized in one line.
	int vecVals[nVals] = {14, 63, 44, 37, 85, 80, 57, 92, 52, 11};
	int listVals[nVals] = {-42, -29, -56, -43, -33, -51, -49, -60, -65, -61};
	int setVals[nVals] = {21, -99, -63, -55, 77, 69, 35, 75, 81, -36};
	
	vector<int> testVec; //Make some containers and put the values in them
	list<int> testList;
	set<int> testSet;
	map<int, int> testMap;
	for(int i = 0; i < nVals; ++i) {
		testVec.push_back(vecVals[i]);
		testList.push_back(listVals[i]);
		testSet.insert(setVals[i]);
		testMap.insert(make_pair(setVals[i], listVals[i]));
	}
	
	assert(maxVal(testVec) == 92);
	cout << "Vector test succeeded! The maximum value is " << maxVal(testVec) << endl;
	assert(maxVal(testList) == -29);
	cout << "List test succeeded! The maximum value is " << maxVal(testList) << endl;
	assert(maxVal(testSet) == 81);
	cout << "Set test succeeded! The maximum value is " << maxVal(testSet) << endl;
	assert(maxVal(testMap) == -65);	
	cout << "Map test succeeded! The maximum value is " << maxVal(testMap) << endl;
	cout << "All tests finished successfully!" << endl;
	
	return 0;
}

/*
Of course, in the real world we could also use the STL algorithm 
max_element to find the maximum of the range between two iterators.
The return value is an iterator which points to the end of the container
if the container is empty. So, for the vector we could do

#include <algorithm>
vector<int>::iterator it = max_element(testVec.begin(), testVec.end());
if(it != testVec.end()) cout << "Found the max! It is " << *it << endl;
*/

