#include "palindrome.h"
#include <cctype> //For tolower
#include <iostream>
using namespace std;

/*
Step through the string, and compare each character to the corresponding
character at the end of the string. If at any point they don't match,
return false. Once half the string has been traversed, we are done.
*/ 
bool isStrictPalindrome(const string str) {
	for(size_t i = 0; i < str.size()/2; ++i) if(str.at(i) != str.at(str.size() - i - 1)) return false;
	return true;
	
	//Here is a more explicit solution that also prints where the match fails
	/*
	size_t first = 0;
	size_t last = str.size() - 1;
	while(last > first) {
		if(str.at(first) != str.at(last)) {
			return false;
			cout << "Returned false when first = " << first << " and last = " << last << endl;
		}
		++first;
		--last;
	}
	return true;
	*/
}

/*
This is really just a one-liner once the appropriate helper functions
have been written. Strip all the non-alphanumeric characters from the
string, then convert it to lower case, then check if it's a palindrome
using the strict function.
*/
bool isPalindrome(const string str) {
	return isStrictPalindrome(convertToLower(convertToAlphanum(str)));
}

string convertToLower(const string str) {
	string toConvert = str; //Copy the original string. We can't modify str because it is const.
	for(size_t i = 0; i < toConvert.size(); ++i) toConvert.at(i) = tolower(toConvert.at(i)); //Convert each character to lower case
	return toConvert; //And return the converted string
}

string convertToAlphanum(const string str) {
	string toConvert = str; //Copy the original string. We can't modify str because it is const.
	size_t i = 0;
	while(i < toConvert.size()) {
		if(!isalnum(toConvert.at(i))) toConvert.erase(i, 1); //Erase all characters that aren't alphanumeric
		else ++i; //Erasing shortens the string size by one, so only increment it if we didn't erase
	}
	return toConvert;
}
