#include <iostream>
#include <fstream>
#include <random>
#include <cmath>
using namespace std;

int main() { //Uses C++0x stuff, compile with -std=gnu++0x
	ofstream outFile("detReadout.dat");
	if(!outFile) {
		cout << "Can't open dataSetFile detReadout.dat" << endl;
		return 1;
	}
	
	random_device rd; //Create a random number generator
	mt19937 gen(rd());

	normal_distribution<> gaus(25,10); //Gaussian with mean 25 and stdev 10
	binomial_distribution<> bino(1, 0.95); //Binomial distribution, 1 trial with 95% chance of success

	for(int i = 0; i < 5000; ++i) outFile << i*0.2 << " " << abs(round(gaus(gen))) << " " << (bino(gen) ? 1 : 0) << endl;
	outFile.close();
	return 0; //After generating, go change some numbers by hand so that they become significant at 5 sigma
}
