#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>

using namespace std;

int main() {
	ifstream inFile("detReadout.dat");
	if(!inFile) {
		cout << "Can't open dataSetFile detReadout.dat" << endl;
		return 1;
	}
	
	double time = 0.;
	int count = 0;
	bool isOk = false;
	
	vector<double> times; //Vectors to store the times and counts
	vector<int> counts;
	
	while(inFile >> time) { //Read each line and store it if it's OK
		inFile >> count;
		inFile >> isOk;
		if(isOk) {
			times.push_back(time);
			counts.push_back(count);
		}
	}
	inFile.close();
	
	double mean = 0.; //To get the standard deviation, begin by calculating the mean and the mean square
	double meanSquare = 0.; //We could have done this in the above loop to save time, but I'll do it here for clarity
	for(size_t i = 0; i < counts.size(); ++i) {
		mean += counts.at(i); //Add up the values
		meanSquare += counts.at(i)*counts.at(i); //Add up the squared values
	}
	mean /= counts.size(); //Now divide by the number of points to get the means
	meanSquare /= counts.size();
	double standardDeviation = sqrt(meanSquare - mean*mean);

	cout << "Mean: " << mean << endl;
	cout << "Stdev: " << standardDeviation << endl;
	for(size_t i = 0; i < counts.size(); ++i) {
		if(fabs(counts.at(i) - mean) > 5*standardDeviation) { //This checks for both positive and negative deviations
			cout << "Suspicious alien activity at " << times.at(i) << " hours: " << counts.at(i) << endl;
		}
	}
	return 0;
}
